const processFlickr = require('./processFlickr');

var Flickr = require("flickrapi"),
    flickrOptions = {
      api_key: "91f5ba411f70f89403c2ded7eb01014b",
      secret: "d8e13e9567322d00",
      progress: false
    };

function getPhotos(flickr, groupId, page) {
  return new Promise((resolve, reject) => {
    flickr.groups.pools.getPhotos({
      group_id: groupId,
      extras: 'geo, url_t, description',
      per_page: 500,
      page: page
    }, (error, photos) => {
      resolve(photos);
    });
  });
}

function getToken(flickrOptions) {
  return new Promise((resolve, reject) => {
    Flickr.tokenOnly(flickrOptions, (error, flickr) => {
      if (error) {
        return reject(error);
      }
      return resolve(flickr);
    });
  });
}

function lookupGroup(groupUrl) {
  return new Promise((resolve, reject) => {
    flickr.urls.lookupGroup({
        url: groupUrl
      }, (error, groupInfo) => {
        if (error) {
          return reject(error);
        }
        return resolve(groupInfo);
      });
  });
}

function getFlickrGroupPhotos(groupUrl) {
  var groupId = null;
  var groupInfo = null;

  return getToken(flickrOptions).
    then((fl) => {
      flickr = fl;
      return flickr;
    }).
    then((flickr) => {
      return lookupGroup(groupUrl);
    }).
    then((gInfo) => {
      groupInfo = gInfo;
      groupId = gInfo.group.id;
      return getPhotos(flickr, groupId, 1);
    }).
    then((photos) => {
      var pages = photos.photos.pages;
      var promises = [Promise.resolve(photos)];
      for(var i=2; i<=pages; i++) {
        promises.push(getPhotos(flickr, groupId, i));
      }

      return Promise.all(promises);
    }).
    then((photosArray) => {
      var total = [];
      photosArray.forEach((photos) => {
        total = total.concat(photos.photos.photo);
      });

      return total;
    }).
    then((total) => {
      console.log(groupInfo);
      var result = processFlickr(total);
      result.group = groupInfo;
      return Promise.resolve(result);
    });
}


// geoJson.then((geojson) => {
//   console.log(JSON.stringify(geojson, null, 2));
// });

module.exports = getFlickrGroupPhotos;
