var express = require('express');
var bodyParser = require('body-parser');
var flickr = require('./flickr');
var app = express();

app.use(bodyParser.json()); // for parsing application/json
app.use(bodyParser.urlencoded({ extended: true })); // for parsing application/x-www-form-urlencoded
app.set('view engine', 'pug');

app.get('/', function (req, res) {
  res.render('index');
});

app.post('/group', function(req, res) {
  if (!req.body) {
    return res.sendStatus(400);
  }

  const group = req.body.group;
  flickr(group).then((geojson) => {
    res.render('group', {data: geojson})
  }, (error) => {
    console.log('Error ', error);
    return res.sendStatus(400);
  });
});

app.listen(3000, function () {
  console.log('App listening on port 3000!');
});
